#
#  tweet_test.rb
#  MRTwitter
#
#  Created by Jerry Cheung on 5/4/11.
#  Copyright 2011 MacRuby in Action. All rights reserved.
#

require 'test_helper'
class TweetTest < MiniTest::Unit::TestCase
  def setup
    app_delegate.removePersistentStores
    app_delegate.initializePersistentStore
  end
  
  def test_latest_tweets
    tweets = Tweet.latest_tweets
    assert tweets.empty?, "Tweets should be empty initially, but has #{tweets.count} instead"

    t1 = NSEntityDescription.insertNewObjectForEntityForName("Tweet", inManagedObjectContext:context)
    t1.createdAt = Time.now - 1000
    t2 = NSEntityDescription.insertNewObjectForEntityForName("Tweet", inManagedObjectContext:context)
    t2.createdAt = Time.now
    assert context.save(nil)

    tweets = Tweet.latest_tweets
    assert_equal [t2, t1], tweets, "Tweets out of order"
  end
end