# PomodoroController.rb
# Pomodoro
#
# Created by Brendan Lim on 8/20/10.
# Copyright 2010 MacRuby in Action. All rights reserved.

class PomodoroController
    attr_accessor :start_stop_button, :timer_label
    attr_accessor :pomodoro_timer, :min_left
    
    def awakeFromNib
        @min_left = 25
    end
    
    def start_stop_pomodoro(sender)
        if @pomodoro_timer.nil?
            @pomodoro_timer = NSTimer.scheduledTimerWithTimeInterval(60, target:self, selector:"min_passed:", userInfo:nil, repeats:true)
            @timer_label.textColor = NSColor.redColor
            @start_stop_button.title = "Stop Pomodoro"
            else
            reset_interface
        end
    end
    
    def min_passed(timer)
        if @min_left > 1
            @min_left -= 1
            @timer_label.stringValue = @min_left
            else
            reset_interface
            timer_finished_alert
        end
    end
    
    def reset_interface
        @min_left = 25
        @timer_label.stringValue = @min_left
        @timer_label.textColor = NSColor.darkGrayColor
        @start_stop_button.title = "Start Pomodoro"
        @pomodoro_timer.invalidate
        @pomodoro_timer = nil
    end
    
    def timer_finished_alert
        voice = NSSpeechSynthesizer.alloc.initWithVoice("com.apple.speech.synthesis.voice.Victoria")
        voice.startSpeakingString("Pomodoro complete. Time for a short break.")
    end
end