#
# TasksController.rb
# Todo Core Data
#
# Created by Brendan Lim on 2/1/11.
# Copyright 2011 MacRuby in Action, Inc. All rights reserved.
#

class TasksController
  attr_accessor :tasks_table_view, :task_text_field
  
  def awakeFromNib
    @tasks = []
    @context = NSApp.delegate.managedObjectContext
    fetch_tasks
  end
  
  def numberOfRowsInTableView(view)
    @tasks.size
  end
  
  def tableView(view, objectValueForTableColumn:column, row:index)
    task = @tasks[index]
    task.valueForKey(column.identifier)
  end
  
  def create_task(sender)
    task = NSEntityDescription.insertNewObjectForEntityForName("Task", inManagedObjectContext:@context)
    task.summary = @task_text_field.stringValue
    task.created_date = Time.now
    
    @task_text_field.stringValue = ""
    NSApp.delegate.saveAction(self)    
    fetch_tasks
  end
  
  def complete_task(sender)
    return if @tasks_table_view.selectedRow == -1

    @tasks[@tasks_table_view.selectedRow].complete!
    NSApp.delegate.saveAction(self)    
    fetch_tasks
  end
  
  def fetch_tasks
    @tasks = []
    request = NSFetchRequest.alloc.init
    request.entity = NSEntityDescription.entityForName("Task", inManagedObjectContext:@context)
    sort_desc = NSSortDescriptor.alloc.initWithKey("created_date", ascending:false)
    request.sortDescriptors = [sort_desc]
    
    error = Pointer.new_with_type('@')
    @tasks = @context.executeFetchRequest(request, error:error)
    @tasks_table_view.reloadData
  end
end



