class AnimationsController
    attr_accessor :image_view
    
    # Basic Animations
    # -------------------------------------------------------
    # def start_animation(sender)
    #    animation = CABasicAnimation.animationWithKeyPath(“opacity”)
    #    animation.fromValue = 1.0
    #    animation.toValue = 0.0
    #    animation.duration = 2.0
    #    
    #    image_view.wantsLayer = true
    #    image_view.layer.addAnimation(animation, forKey:”opacity”)
    # end
    
    # Keyframe Animations
    # -------------------------------------------------------
    # def start_animation(sender)
    #    animation = CAKeyframeAnimation.animationWithKeyPath("opacity")
    #    animation.values = [1.0,0.0]					
    #    animation.keyTimes = [0.0,1.0]					
    #    animation.duration = 2.0						
    #    
    #    image_view.wantsLayer = true					
    #    image_view.layer.addAnimation(animation, forKey:"opacity")
    # end
    
    
    # Grouped Animations
    # -------------------------------------------------------
    def start_animation(sender)
        image_view.wantsLayer = true
        image_view.layer.addAnimation(animationGroup, forKey:nil)
    end
    
    def animationGroup
        group = CAAnimationGroup.animation
        group.animations = [scaleAnimation, opacityAnimation]
        group.autoreverses = true
        group.duration = 6.0
        group
    end
    
    # need to isntall bridge support
    def scaleAnimation
        scale = CABasicAnimation.animationWithKeyPath("transform")
        scale.fromValue = NSValue.valueWithCATransform3D(CATransform3DIdentity)
        scale.toValue = NSValue.valueWithCATransform3D(CATransform3DMakeScale(0.1,0.1,0.1))
        scale
    end
    
    def opacityAnimation
        opacity = CABasicAnimation.animationWithKeyPath("opacity")
        opacity.fromValue = 1.0
        opacity.toValue = 0.0
        opacity
    end
end