require 'rubygems'
require 'hotcocoa'

class Application
  include HotCocoa
  
  def start
    application :name => "Speak" do |app|
      app.delegate = self
      window :size => [400, 80], :center => true,  :title => "Speak" do |win|
        horiz = layout_view(:frame => [0, 0, 0, 40], 
                            :mode => :horizontal,
                            :layout => {
                              :padding => 0, 
                              :margin => 0,
                              :start => false, 
                              :expand => [:width]}) do |horiz|
                                                    
          @field = text_field(:layout => {:expand => [:width]})
          horiz << @field

          @button = button(:title => "Speak", :layout => {:align => :center})
          @button.on_action { speak }
          horiz << @button
        end
        
        win << horiz        
        win.will_close { exit }
      end
    end
  end
  
  def speak
    synth = NSSpeechSynthesizer.new
    synth.voice = "com.apple.speech.synthesis.voice.Vicki"
    synth.startSpeakingString(@field.stringValue)
  end
end

Application.new.start